Scalaに入門した α

# 目的

sbtの導入まで進める

# 対象

* Scala してない人

# 内容

* Scalaのインストール
* Hello, World
* 外部ライブラリの利用
* sbtを使う

## Scalaのインストール

brew install scala

## Hello, World

scala -e 'println("Hello, Z")'

scala hello.scala

### コンパイル

scalac hello.scala

```
hello.scala:1: error: expected class or object definition
println("Hello, Z")
^
one error found
```

scalac hello_compile.scala
scala Hello

```
object HelloScala2 extends App {
  println("Hello, Z")
}
```

```
object HelloScala {
  def main(args: Array[String]) : Unit =
    println("Hello, Z")
}
```

```
public class Hello {
  public static void main(String[] args) {
     System.out.println("Hello, Z");
  }
}
```

### 外部ライブラリを使う


maven central repository というところにある
http://search.maven.org/



curl -OL 'http://search.maven.org/remotecontent?filepath=org/scalaz/scalaz-core_2.12.0-M1/7.1.2/scalaz-core_2.12.0-M1-7.1.2.jar'



import scalaz.Scalaz._
val hello = (str: String) => "Hello, " + str
val z = (str: Option[String]) => str.getOrElse("Z")
(hello <<< z)(None)   // "Hello, Z"


import scalaz.Scalaz._

class HelloScalaz extends App {
  val hello = (str: String) => "Hello, " + str
  val z = (str: Option[String]) => str.getOrElse("Z")

  println((hello <<< z)(args.headOption))
}


curl -O https://repo1.maven.org/maven2/org/scalaz/scalaz-core_2.11/7.1.2/scalaz-core_2.11-7.1.2.jar
curl -O https://repo1.maven.org/maven2/org/scala-lang/scala-library/2.11.5/scala-library-2.11.5.jar


~/.ivy2/cache/


scala -cp "scalaz-core_2.11-7.1.2.jar:." HelloZ World

悩んだ分だけ前に進めるようになりたいね。
https://twitter.com/eielh/status/597799053489872897

理想の自分を装う精一杯な毎日だわ
https://twitter.com/eielh/status/599963637025886208

昔、考えたこと、悩んだことはなんとなく体の中を活きてるものなんだなぁ。
https://twitter.com/eielh/status/601413989315190784

手をひいていく姿が浮かぶ。未来へ進むために。
https://twitter.com/eielh/status/601729855122608132

# 参考文献

https://speakerdeck.com/takahiro/hazimetefalseguan-shu-xing-puroguramingujiao-shi
http://d.hatena.ne.jp/Kazuhira/20130320/1363791795
